% Rzo = Rotation matrix between parent coordinate frame and coordinate frame
% moving with limb, when limb is at home position i.e. all joint angles for
% this limb (w.r.t. parent frame) are zero
% ab = uni vector along limb in home position (given in coordinates wrt parent frame)
function [Rzo] = createZeroOffsetMatrix(ab)

% Rzo * [0 0 1]' = ab
% find alpha , beta
% set gamma = 0 by choice
% create Rzyx(g,b,a)

beta = atan2(ab(1) , sqrt(ab(2)^2+ab(3)^2)) * 180/pi;
if (cosd(beta) < 1e-9) % nearly zero
    alpha = 0; % any alpha would've satisfied. Therefore, choose zero
else
    alpha = atan2( -ab(2)/cosd(beta) , ab(3)/cosd(beta) ) *180/pi;
end
gamma = 0;

Rzo = getRzyx(gamma, beta, alpha);