% markerpositions = 1xN,
% N = number of virtual markers
% mp = 1x(3*N)
% dotsHome = 1x(3*N)
% angles = 1x3
% R = 3x3
function [R, angles] = getPelvisRotation(mp, dotsHome,skeleton,N)

mp = mp - repmat(mp((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3), 1,N);
dotsHome = dotsHome - repmat(dotsHome((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3),1,N);

% home pose, coordinate frame
% h2 = dotsHome((skeleton.UPPERLEGL-1)*3+1:(skeleton.UPPERLEGL-1)*3+3) ...
%     - dotsHome((skeleton.UPPERLEGR-1)*3+1:(skeleton.UPPERLEGR-1)*3+3); 
h2 = dotsHome((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3) ...
    - dotsHome((skeleton.UPPERLEGR-1)*3+1:(skeleton.UPPERLEGR-1)*3+3); 
h2 = h2/norm(h2); % y axis unit vector
h3 = dotsHome((skeleton.LOWERBACK-1)*3+1:(skeleton.LOWERBACK-1)*3+3) ...
    - dotsHome((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3);
% z axis unit vector is the component of h3 which is perpendicular to h2
h3p = h3 - dot(h2,h3)*h2;
h3p = h3p/norm(h3p); 
h1 = cross(h2,h3p); % x axis unit vector

% current pose, coordinate frame
p3 = mp((skeleton.LOWERBACK-1)*3+1:(skeleton.LOWERBACK-1)*3+3) ...
    - mp((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3); 
% y axis is obtained by averaging two vectors
% p21 = mp((skeleton.UPPERLEGL-1)*3+1:(skeleton.UPPERLEGL-1)*3+3) ...
%     - mp((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3); 
% p21 = p21/norm(p21);
% p22 = mp((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3) ...
%     - mp((skeleton.UPPERLEGR-1)*3+1:(skeleton.UPPERLEGR-1)*3+3); 
% p22 = p22/norm(p22);
% p2 = (p21+p22)/2;

% p2 = mp((skeleton.UPPERLEGL-1)*3+1:(skeleton.UPPERLEGL-1)*3+3) ...
%     - mp((skeleton.UPPERLEGR-1)*3+1:(skeleton.UPPERLEGR-1)*3+3); 
p2 = mp((skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+3) ...
    - mp((skeleton.UPPERLEGR-1)*3+1:(skeleton.UPPERLEGR-1)*3+3); 
p2 = p2/norm(p2);
% z axis unit vector is the component of p3 which is perpendicular to p2
p3p = p3 - dot(p2,p3)*p2;
p3p = p3p/norm(p3p); 
p1 = cross(p2,p3p); % x axis unit vector

H = [h1' ,h2',h3p'];
P = [p1', p2',p3p'];
% R*H = P
R = P*H'; % inverse = transpose
[g,a,b,g2,b2,a2] = getRotationsXYZ(R);

angles = [g,a,b];

% check 
%R*reshape(dotsHome(1,[10:12 13:15 34:36 46:48]),3,[]) + repmat(mp1(13:15)',1,4) - reshape(mp1(1,[10:12 13:15 34:36 46:48]),3,[])
%R*reshape(dotsHome(1,[10:12 13:15 34:36 46:48]),3,[]) - reshape(mp(1,[10:12 13:15 34:36 46:48]),3,[])

