% Rotation matrix Rxyz is for rotations in the order xyz
% g is the first rotation, i.e. about x axis
% b is the second rotation, i.e. about y axis
% a is the third rotation, i.e. about z axis
function [g,b,a, g2,b2,a2] = getRotationsXYZ(Rxyz)

b = atan2( -Rxyz(3,1), sqrt( Rxyz(1,1)^2 + Rxyz(2,1)^2 ) ) * 180/pi; % about y axis
if (abs(cosd(b)) < 1e-9) % nearly zero
    if (sind(b)>0) % beta is +90
        a = 0; % any alpha would've satisfied. Therefore, choose zero
        g = atan2( Rxyz(1,2), Rxyz(2,2) ) * 180/pi; % about x axis
    elseif (sind(b)<0) % beta is -90
        a = 0; % any alpha would've satisfied. Therefore, choose zero
        g = -atan2( Rxyz(1,2), Rxyz(2,2) ) * 180/pi; % about x axis
    end
else
    g = atan2( Rxyz(3,2)/cosd(b) , Rxyz(3,3)/cosd(b) ) * 180/pi; % about x axis
    a = atan2( Rxyz(2,1)/cosd(b) , Rxyz(1,1)/cosd(b) ) * 180/pi; % about z axis
end


b2 = atan2( -Rxyz(3,1), -sqrt( Rxyz(1,1)^2 + Rxyz(2,1)^2 ) ) * 180/pi; % about y axis
if (abs(cosd(b)) < 1e-9) % nearly zero
    if (sind(b2)>0) % beta is +90
        a2 = 0; % any alpha would've satisfied. Therefore, choose zero
        g2 = atan2( Rxyz(1,2), Rxyz(2,2) ) * 180/pi; % about x axis
    elseif (sind(b2)<0) % beta is -90
        a2 = 0; % any alpha would've satisfied. Therefore, choose zero
        g2 = -atan2( Rxyz(1,2), Rxyz(2,2) ) * 180/pi; % about x axis
    end
else
    g2 = atan2( Rxyz(3,2)/cosd(b2) , Rxyz(3,3)/cosd(b2) ) * 180/pi; % about x axis
    a2 = atan2( Rxyz(2,1)/cosd(b2) , Rxyz(1,1)/cosd(b2) ) * 180/pi; % about z axis
end


