% For a 2 link system, given end points and limb lengths, what should the position of the middle
% point be ? 

function [point] = ik_2d( p1, p2, l1, l2, pref )

a = p2(1) - p1(1);
b = p2(2) - p1(2); 

ctheta2 = ( a^2 + b^2 - (l1^2 + l2^2) ) / (2*l1*l2) ;

% check if soln feasible
if (abs(ctheta2) > 1)
    %disp('why is cosine>1 ? '); keyboard;
    point = pref; return
end

stheta2_a = sqrt( 1-ctheta2^2 );
stheta2_b = -1 * sqrt( 1-ctheta2^2 );

% ---- a ----
k1 = l1 + l2*ctheta2;
k2 = l2*stheta2_a;
ctheta1 = (k1*a + k2*b) / ( k1^2 + k2^2 );
stheta1 = (k1*b - k2*a) / ( k1^2 + k2^2 );
pointa(1) = p1(1) + l1*ctheta1;
pointa(2) = p1(2) + l1*stheta1;
% ----

% ---- b ----
k1 = l1 + l2*ctheta2;
k2 = l2*stheta2_b;
ctheta1 = (k1*a + k2*b) / ( k1^2 + k2^2 );
stheta1 = (k1*b - k2*a) / ( k1^2 + k2^2 );
pointb(1) = p1(1) + l1*ctheta1;
pointb(2) = p1(2) + l1*stheta1;
% ----

if ( norm(pref - pointa) < norm(pref - pointb) )
    point = pointa;
else
    point = pointb;
end

