% Al * markerpositions' = Bl is a system that constrains limb lengths 
function [A, b] = limblengthlinearize(point, limblengths, skeleton, c,m3d)

[I,J] = find(skeleton.H); % which'th markers are connected by limbs

pointr = reshape(point,3,[]);
Al = zeros(length(I),skeleton.N*3);
Bl = zeros(length(I),1);

for ctr=1:length(I)
   m1 = pointr(:,I(ctr));
   m2 = pointr(:,J(ctr));
   Bl(ctr) = limblengths(ctr).^2 - [sum((m1-m2).^2)] + ...
             2*m1(1)*(m1(1)-m2(1)) - 2*m2(1)*(m1(1)-m2(1)) + ...
             2*m1(2)*(m1(2)-m2(2)) - 2*m2(2)*(m1(2)-m2(2)) + ...
             2*m1(3)*(m1(3)-m2(3)) - 2*m2(3)*(m1(3)-m2(3));
    
   Al( ctr, [(I(ctr)-1)*3+1:(I(ctr)-1)*3+3 , (J(ctr)-1)*3+1:(J(ctr)-1)*3+3 ] ) = [ 2*(m1(1)-m2(1)) -2*(m1(1)-m2(1)) ...
                                                                                   2*(m1(2)-m2(2)) -2*(m1(2)-m2(2)) ...
                                                                                   2*(m1(3)-m2(3)) -2*(m1(3)-m2(3)) ];
  
end


A = Al*c;
b = Bl - Al*m3d';


