% querysegment = numFrames x (numDots*2) = hand drawn frames
% result2d = numFrames x (numDots*2) = the frames that need to be modified
% to match the query frames
% match = numFrames x (numDots*2) = modified frames

function [match] = modifyinplane(querysegment,result2d, skeleton, smoothingflag)

numframes = size(querysegment,1);

for i=1:numframes
    % Rotate each limb segment in the plane of the image to match to the
    % hand-drawn limb segment. (see Section 3.4)
    match(i,:) = makematch(querysegment(i,:),result2d(i,:), ...
        skeleton.linkchain,[skeleton.LOWERBACK, skeleton.UPPERBACK, skeleton.BASENECK, skeleton.NECK ...
                            skeleton.UPPERARML, skeleton.LOWERARML, skeleton.HANDL, ...
                            skeleton.UPPERARMR, skeleton.LOWERARMR, skeleton.HANDR, ...
                            ],...
        [skeleton.UPPERBACK skeleton.BASENECK, skeleton.NECK, skeleton.HEAD, ...
        skeleton.LOWERARML, skeleton.HANDL, skeleton.FINGERTIPSL ...
        skeleton.LOWERARMR, skeleton.HANDR skeleton.FINGERTIPSR ...
         ], skeleton); 
   
end

if (smoothingflag)
    matchsmooth = match;
    for i =1 : (2*skeleton.N) 
        matchsmooth(:,i) = smooth(match(:,i)); 
    end
    match = matchsmooth;
end



