% rotate sequence so that the first frame has zero yaw and tx=ty=0. All subsequent
% frames are rotated and translated with respect to this.

function [d2d,d3d,R] = project3dworldto2dimage_seqwise(dots, ja, az,el, H, skeleton, N)

T = viewmtx(az,el); 
R = T(1:3,1:3); Q = R(1:2,:); % Q is the orthographic projection

R1 = getRxyz(0,0,-ja(1,6));
t1 = [ dots(1,(skeleton.PELVIS-1)*3+1:(skeleton.PELVIS-1)*3+2) ,0 ]';

for i=1:size(dots,1)   
    d = reshape(dots(i,:),3,[]);   
    dt1 = d - repmat(t1,1,N); 
    dt1r1 = R1 * dt1;
    drtmatch = Q * dt1r1;
%     plotStickFigure2D(drtmatch(1,:),drtmatch(2,:),H,'.','g'); axis equal
%     hold off
%     drawnow
%     disp(i)
    drtmatch2d = drtmatch(1:2,:);
    d2d(i,:) = drtmatch2d(:)';   
    d3d(i,:) = dt1r1(:)';
end

return