% this is a function to write joint angles to a text file
% Inputs    : filename = filename of the file to write to.
%           : jointangles = a vector containing the joint angles in the
%           order in which they have to be written to file
%           : resolution = a string like +3.2f or +.8f or something like
%           that

function writeToFile (filename, jointangles, resolution, mode)

    fid = fopen( filename, mode ); % Open file in 'mode' mode i.e. 'w' or 'a'
    resolution_string = ['%' resolution];
    MAX_CTR = length(jointangles);
    for ctr = 1:MAX_CTR 
        fprintf( fid, resolution_string , jointangles(ctr) ); % Always prints a sign character (+ or -)
        if (ctr < MAX_CTR)
            fprintf( fid , ' ' ); % don't put a space at the end of an array, only in between them
        end
    end % ctr

    fclose(fid);